Elektra: kdb::tools::MockPluginDatabase Class Reference

Elektra 0.8.24

Public Member Functions | Public Attributes | List of all members
kdb::tools::MockPluginDatabase Class Reference

A plugin database that works with added fake data. More...

`#include <plugindatabase.hpp>`

Inherits kdb::tools::ModulesPluginDatabase.

## Public Member Functions
std::vector< std::string > | listAllPlugins () const
| list all plugins More...
std::string | lookupInfo (PluginSpec const &spec, std::string const &which) const
| lookup contract clauses or dynamic information More...
func_t | getSymbol (PluginSpec const &whichplugin, std::string const &which) const
| get exported plugin symbol More...
Public Member Functions inherited from kdb::tools::ModulesPluginDatabase
PluginSpec | lookupMetadata (std::string const &which) const
| lookup which plugin handles metadata More...
PluginSpec | lookupProvides (std::string const &provides) const
| lookup which plugin is a provider for that plugin More...
std::map< int, PluginSpec > | lookupAllProvidesWithStatus (std::string const &provides) const
| looks up all plugins which are a suitable provider More...
std::vector< PluginSpec > | lookupAllProvides (std::string const &provides) const
| looks up all plugins which are a suitable provider More...

## Public Attributes
std::unordered_map< PluginSpec, std::unordered_map< std::string, std::string >, PluginSpecHash, PluginSpecName > | data
| only data from here will be returned More...

## Additional Inherited Members
Public Types inherited from kdb::tools::PluginDatabase
enum | Status { provides, real, missing }
Static Public Member Functions inherited from kdb::tools::PluginDatabase
static int | calculateStatus (std::string statusString)

## Detailed Description

A plugin database that works with added fake data.

## Member Function Documentation

## ◆ getSymbol()

PluginDatabase::func_t kdb::tools::MockPluginDatabase::getSymbol | ( | PluginSpec const & | whichplugin,
|  | std::string const & | which
| ) |  | const
| virtual

get exported plugin symbol

Parameters

  whichplugin | from which plugin?
  which | which symbol would you like to look up?

Returns
  the function pointer to the exported symbol or NULL if the symbol was not found

Reimplemented from kdb::tools::ModulesPluginDatabase.

## ◆ listAllPlugins()

std::vector< std::string > kdb::tools::MockPluginDatabase::listAllPlugins | ( |  | ) | const
| virtual

list all plugins

If Elektra is compiled with plugins, it will search for shared libraries. In any case, if no shared libraries were found it will fallback to an internal list (plugins that were compiled together with Elektra).

Returns
  a list of all available plugins

Reimplemented from kdb::tools::ModulesPluginDatabase.

## ◆ lookupInfo()

std::string kdb::tools::MockPluginDatabase::lookupInfo | ( | PluginSpec const & | whichplugin,
|  | std::string const & | which
| ) |  | const
| virtual

lookup contract clauses or dynamic information

Parameters

  whichplugin | about which plugin?
  which | about which clause in the contract?

Returns
  the clause of the contract

Reimplemented from kdb::tools::ModulesPluginDatabase.

## Member Data Documentation

## ◆ data

std::unordered_map<PluginSpec, std::unordered_map<std::string, std::string>, PluginSpecHash, PluginSpecName> kdb::tools::MockPluginDatabase::data
| mutable

only data from here will be returned

Note
  that it is ordered by name, i.e., different ref-names cannot be distinguished

The documentation for this class was generated from the following files:

- plugindatabase.hpp
- plugindatabase.cpp